/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.utilerias;

import com.rjconsultores.ventaboletos.entidad.Ciudad;
import com.rjconsultores.ventaboletos.service.CiudadService;
import java.util.ArrayList;
import java.util.List;

import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.WrongValueException;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zk.ui.event.InputEvent;
import org.zkoss.zkplus.databind.BindingListModel;
import org.zkoss.zkplus.databind.BindingListModelList;
import org.zkoss.zkplus.spring.SpringUtil;
import org.zkoss.zul.Combobox;

/**
 *
 * @author rodrigo
 */
public class MyComboboxCiudad extends Combobox {

    private CiudadService ciudadService;
    private List<Ciudad> lsCiudad;
    private Ciudad initialValue;
    private Integer indiceSelected = null;

    public MyComboboxCiudad() {

        super();

        ciudadService = (CiudadService) SpringUtil.getBean("ciudadService");
        lsCiudad = new ArrayList<Ciudad>();

        this.setAutodrop(false);
        this.setAutocomplete(false);

       
        this.addEventListener("onOK", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                String strCiudad = MyComboboxCiudad.this.getText().toUpperCase();

                if (strCiudad.length() < MyComboboxParada.minLength) {
                    return;
                }
                if (!strCiudad.isEmpty()) {
                    lsCiudad = ciudadService.buscaLike(strCiudad);

                    BindingListModel listModelCiudad = new BindingListModelList(lsCiudad, true);
                    MyComboboxCiudad.this.setModel(listModelCiudad);
                    indiceSelected = null;
                    if (!lsCiudad.isEmpty()) {
                        indiceSelected = 0;
                    }

                    MyComboboxCiudad.this.open();
                } else {
                    lsCiudad.clear();

                    BindingListModel listModelCiudad = new BindingListModelList(lsCiudad, true);
                    MyComboboxCiudad.this.setModel(listModelCiudad);
                }
            }
        });

        this.addEventListener("onChanging", new EventListener() {

            public void onEvent(Event event) throws Exception {
                InputEvent ev = (InputEvent) event;
                String strCiudad = ev.getValue();
                if (strCiudad.length() < 2) {
                    lsCiudad.clear();

                    BindingListModel listModelCiudad = new BindingListModelList(lsCiudad, true);
                    MyComboboxCiudad.this.setModel(listModelCiudad);

                    MyComboboxCiudad.this.close();
                }
            }
        });
    }

    public Ciudad getInitialValue() {
        return initialValue;
    }

    public void setInitialValue(Ciudad initialValue) {
        if (initialValue == null) {
            return;
        }
        List<Ciudad> ls = new ArrayList<Ciudad>();
        ls.add(initialValue);

        this.setModel(new BindingListModelList(ls, false));
    }
    
	/**
	 * 
	 * @param checaBusqueda
	 * @throws WrongValueException
	 */
	public String getValue(boolean checaBusqueda) throws WrongValueException {
		if (checaBusqueda) {
			if (this.getSelectedItem() == null) {
				throw new WrongValueException(this, Labels.getLabel("MSG.Error.combobox.hacerBusqueda"));
			}
		}

		return super.getValue();
	}
}
